%% ****************************************
%% ************ Spec Language *************
%% ****************************************

\begin{figure}%[htb!]
\begin{center}
{
\[\arraycolsep=1pt
\begin{array}{llll}
  \text{(Symbolic pred.)} & \mathit{pred} &::=&
  \code{\view{\pred}{\vect{v}}~{\veq}~
                                      \constr~ \inv~ \pure}
  \qquad

  \\
  \text{(Formula)} &   \constr & ::=& \bigvee \St
  \qquad \qquad \St  ::= \code{ \exists ~ \vect{v}{\cdot}\heap{\wedge}\pure
                        ~|~ \St * \St }
  \\
  %Resource
  \text{(Spatial ~formula)} & \heap &::=&
      \code{  \emp
        ~|~ \node{v}{d}{\vect{v}}
        ~|~ \view{\pred}{\vect{v}}
      ~|~ \heap * \heap
      ~|~ \hov }
  \quad
  \\
  \text{(Pure)} &\pure &::=&
  \code{ % v:t
    {b} \mid {\arith} \mid
                \pure {\wedge} \pure \mid \pure {\vee} \pure \mid \neg
                \pure }%   \\
  % &&&
  \code{ \mid \exists v \cdot \pure \mid \forall v \cdot \pure \mid \ptr}
  \\
  \text{(Pointer~ eq./diseq.)} & \ptr &::=&
  \code{  v {=} v ~|~ v{=}\nil ~|~ v{\neq}v ~|~ v{\neq}\nil }
  \\
  \text{(Boolean)} & \code{b} &::=&
  \code{ ~\!\true \mid \false
  \mid {b} \!=\! {b} \qquad
  {\arith} ::= \!\arith {=} \arith
  \mid \arith {\leq} \arith
  \mid \hov{=}\St }
  \\
  \text{(Presburger~ Arith.)~} & \code{\arith} &::=&~
  \code{  \!\const^{\tau} \mid v \mid \const^{\tau}{\times}\arith
  \mid \arith \!+\! \arith
  \mid - \arith  } \\
\text{(Bag Constraint)} & \code{\bagconstr} &::=&~
  \code{v {\in} \bag
    ~|~ \bag {=} \bag
    ~|~ \bag {\bagsubsume} \bag
    ~|~ \forall v {\in} \bag {\cdot} \pure
    ~|~ \exists v {\in} \bag {\cdot} \pure}\\
&\code{\bag} &::=&~ \code{\bag {\bagunion} \bag
  ~|~ \bag {\bagintersect} \bag
  ~|~ \bag {\bagsubtract} \bag
  ~|~ \emptyset
  ~|~ \{v\}} \\
  &&& \\
  &\text{where} &&  \code{ \const^{\tau}} \text{~: constant of type }\tau; ~ \code{v} \text{~:~ first~ order~ variable};\\
  &&& \code{ \hovars} \text{~:~ second-order~ variable}; \\
  &&& \code{d} \text{~:~ name~ of~ a ~user-defined~ data~ structure}\\
\end{array}
\]
}
\hrule
\end{center}
\caption{The Specification Language}
\label{fig.spec_syntax}

\end{figure}

%%% Local Variables:
%%% mode: latex
%%% TeX-master: "../main"
%%% End:
